"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getDetector;

var _lodash = _interopRequireDefault(require("lodash.isregexp"));

var _lodash2 = _interopRequireDefault(require("lodash.isfunction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hasOwn = function hasOwn(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key);
};

function getDetector(_ref) {
  var pattern = _ref.pattern;
  var detector;

  if (pattern) {
    if ((0, _lodash2.default)(pattern)) {
      detector = pattern;
    } else if ((0, _lodash.default)(pattern)) {
      detector = function detector(text) {
        return pattern.test(text);
      };
    } else {
      detector = function detector(text) {
        return pattern === text;
      };
    }
  } else {
    detector = function detector(text) {
      return /[\u4e00-\u9fa5]/.test(text);
    };
  }

  var cache = {};
  return function (text) {
    if (text === '__proto__') {
      // __proto__ property could not be set, it's value of 'cache' is always {}
      return false;
    }

    if (!hasOwn(cache, text)) {
      cache[text] = !!detector(text);
    }

    return cache[text];
  };
}

module.exports = exports["default"];